/*
    SDL - Simple DirectMedia Layer
    Copyright (C) 1997-2009 Sam Lantinga

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Sam Lantinga
    slouken@libsdl.org
*/
module org.libsdl.mutex;

import org.libsdl.stdinc;

immutable Uint32 SDL_MUTEX_TIMEDOUT = 1;
immutable Uint32 SDL_MUTEX_MAXWAIT = 0xffffffff;

struct SDL_mutex {}

extern (C)
{
	SDL_mutex* SDL_CreateMutex();
	int SDL_mutexP(SDL_mutex* mutex);
	alias SDL_mutexP SDL_LockMutex;
	int SDL_mutexV(SDL_mutex* mutex);
	alias SDL_mutexV SDL_UnlockMutex;
	void SDL_DestroyMutex(SDL_mutex* mutex);
}

struct SDL_semaphore {}
alias SDL_semaphore SDL_sem;

extern (C)
{
	SDL_sem* SDL_CreateSemaphore(Uint32 initial_value);
	void SDL_DestroySemaphore(SDL_sem* sem);
	int SDL_SemWait(SDL_sem* sem);
	int SDL_SemTryWait(SDL_sem* sem);
	int SDL_SemWaitTimeout(SDL_sem* sem, Uint32 ms);
	int SDL_SemPost(SDL_sem* sem);
	Uint32 SDL_SemValue(SDL_sem* sem);
}

struct SDL_cond {}

extern (C)
{
	SDL_cond* SDL_CreateCond();
	void SDL_DestroyCond(SDL_cond* cond);
	int SDL_CondSignal(SDL_cond* cond);
	int SDL_CondBroadcast(SDL_cond* cond);
	int SDL_CondWait(SDL_cond* cond, SDL_mutex* mut);
	int SDL_CondWaitTimeout(SDL_cond* cond, SDL_mutex* mutex, Uint32 ms);
}
